$index_html_template = @(END)
<html>
	<head>
		<title>PSADMIN.IO</title>
		<META http-equiv="refresh" content="0;URL='<%= @root_signon_url %>'" />
	</head>
	<body>
	</body>
</html>
	END

# For each domain
$pia_domain_list = hiera('pia_domain_list')
if $pia_domain_list {
	$pia_domain_list.each |$domain_name, $pia_domain_info| {

		$baseWebPath = "${pia_domain_info['ps_cfg_home_dir']}\\webserv\\${domain_name}\\applications\\peoplesoft\\PORTAL.war"
		$root_signon_url = $pia_domain_info['root_signon_url']
		
		file {"${baseWebPath}\\healthCheck.html":
	    ensure      => file,
	    source      => "puppet:///modules/custom_signon/healthCheck.html",
	    source_permissions => ignore,
		}	
		file { "${baseWebPath}\\index.html":
	      ensure    => file,
	      content   => inline_template($index_html_template),
	    }

	    # For each site
		$pia_site_list = $pia_domain_info['site_list']
		$pia_site_list.each |$site_name, $site_info| {

			$htmlPath = "${baseWebPath}\\${site_name}\\"
			$configPath = "${baseWebPath}\\WEB-INF\\psftdocs\\${site_name}"
			
		  file {"${htmlPath}\\custom.png":
		    ensure      => file,
		    source      => "puppet:///modules/custom_signon/custom.png",
		    source_permissions => ignore,
			}	
		  file {"${htmlPath}\\custom.js":
		    ensure      => file,
		    source      => "puppet:///modules/custom_signon/custom.js",
		    source_permissions => ignore,
			}	
		  # configuration files for the WEB-INF\psftdocs folder	
		  file {"${configPath}\\custom.html":
		    ensure      => file,
		    source      => "puppet:///modules/custom_signon/custom.html",
		    source_permissions => ignore,
			}	

		# Set Web Profile since DPK limits to delivered profile names	
	    $webprofile_settings = $site_info['webprofile_settings']
	    file_line { "${site_name}-webProfile":
	      path    => "${configPath}/configuration.properties",
	      match   => 'WebProfile=',
	      line    => "WebProfile=${webprofile_settings['web_profile_name']}",
	    }

	    # Update text.properties file with custom values
	    $text_properties = $site_info['text_properties']
	    if $text_properties {
		    $text_properties.each |$key, $value| {
		      file_line { "${site_name}-${key}": 
		        path    => "${configPath}/text.properties",
		        line    => "${key}=${value}",
		      	}
		      }
			}		
		} #end if
	}
} # if $pia_domain_list
