$tools_version = hiera('tools_version')
$peoplesoft_base = hiera('peoplesoft_base')
$ps_home_dir = hiera('ps_home_location')
$ps_cfg_home_dir = "${peoplesoft_base}/emfhub-${tools_version}"
$ps_cfg_home_dir_norm = normalize_path($ps_cfg_home_dir)
$emfHubPort = 8080
$emfHubPortSSL = 8090

$webserver_settings = [
  "webserver_type            = weblogic",
  "webserver_home            = e:/oracle/weblogic",
  "webserver_admin_user      = system",
  "webserver_admin_user_pwd  = password",
  "webserver_admin_port      = ${emfHubPort}",
  "webserver_http_port       = ${emfHubPort}",
  "webserver_https_port      = ${emfHubPortSSL}",
]

$webprofile_settings = [
  'profile_user              = PTWEBSERVER,
   profile_name              = DEV,
   profile_user_pwd          = password,'
]

$site_settings = [
  "appserver_connections     = server:9000",
  "domain_conn_pwd           = passowrd",
  "report_repository_dir     = //psreports/psreports",
  "webprofile_settings       = $webprofile_settings",
]

$emf_site = ["emf = $site_settings"]
# $site     = strip_keyval_array($emf_site)

pt_webserver_domain { "emfhub-${tools_version}":
  ensure              => 'present',
  os_user             => '',
  ps_home_dir         => "${ps_home_dir}",
  ps_cfg_home_dir     => $ps_cfg_home_dir,
  webserver_settings  => $webserver_settings,
  site_list           => $emf_site,
  gateway_user_pwd    => 'password',
  auth_token_domain   => '.psadmin.io',
} -> 
exec{ "$emfhub-${tools_version}-PIAService": 
    command   => "C:\\Windows\\System32\\cmd.exe /c ${ps_cfg_home_dir_norm}\\webserv\\emfhub-${tools_version}\\bin\\installNTservicePIA.cmd",
}

file {"${ps_cfg_home_dir_norm}\\webserv\\emfhub-${tools_version}\\applications\\peoplesoft\\PSEMHUB.war\\data":
  ensure => directory,
} -> 
file_line { "EMF-Data-Copy": 
  path    => "${peoplesoft_base}\\pt-${tools_version}\\PSEMViewer\\GetEnvInfo.bat",
  match   => "^COPY",
  line    => "COPY .\\envmetadata\\data ${ps_cfg_home_dir_norm}\\webserv\\emfhub-${tools_version}\\applications\\peoplesoft\\PSEMHUB.war\\data /Y",
} 

scheduled_task { 'PSEMViewer':
  ensure    => present,
  enabled   => true,
  command   => "${peoplesoft_base}\\pt-${tools_version}\\PSEMViewer\\GetEnvInfo.bat",
  arguments => "-port ${emfHubPort}",
  working_dir => "${peoplesoft_base}\\pt-${tools_version}\\PSEMViewer",
  trigger   => {
    schedule   => daily,
    every      => 1,            # Specifies every other day. Defaults to 1 (every day).
    start_time => '08:00',      # Must be specified
  }
}
